unit BTCommonConversionsUtil;

 {* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
  * Copyright (c) 2006 by Martin Offenwanger / coder@dsplayer.de            *
  * http://www.dsplayer.com                                                 *
  *                                                                         *
  * This library is free software; you can redistribute it and/or           *
  * modify it under the terms of the GNU Lesser General Public              *
  * License as published by the Free Software Foundation; either            *
  * version 2.1 of the License, or (at your option) any later version.      *
  *                                                                         *
  * This library is distributed in the hope that it will be useful,         *
  * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
  * Lesser General Public License for more details.                         *
  *                                                                         *
  * You should have received a copy of the GNU Lesser General Public        *
  * License along with this library; if not, write to the Free Software     *
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA *
  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{
@author(Martin Offenwanger: coder@dsplayer.de)
@created(Jul 17, 2006)
@lastmod(Nov 01, 2006)
@version(0.12 alpha)
}

{$IFDEF FPC}
{$MODE Delphi}
{$ENDIF}

interface

uses SysUtils, Controls;

function BTByteArrayToBitString(const f_BYTEArray: array of Byte;
  f_Size: Integer; out f_BitString: string): Boolean;
  
function BTTStringArrayOfChar(const f_String: string;
  out f_ArrayOfChar: array of Char): Boolean;


implementation

function BTByteArrayToBitString(const f_BYTEArray: array of Byte;
  f_Size: Integer; out f_BitString: string): Boolean;
var
  BitMasc: Byte;
  j, k: Integer;
begin
  Result := False;
  if f_Size <= 0 then
    exit;
  f_BitString := EmptyStr;
  for j := 0 to f_Size - 1 do
  begin
    BitMasc := 128;
    // 1 to 8 because -> 1 Byte = 8 Bit
    for k := 1 to 8 do
    begin
      if (f_BYTEArray[j] and BitMasc = BitMasc) then
        f_BitString := f_BitString + '1'
      else
        f_BitString := f_BitString + '0';
      BitMasc := BitMasc div 2;
    end;
  end;
  Result := True;
end;

function BTTStringArrayOfChar(const f_String: string;
  out f_ArrayOfChar: array of Char): Boolean;
var
  i: Integer;
  MaxLoopVal: Integer;
begin
  Result := false;
  try
    // Zero dest buffer (just for confidence...)
    FillChar(f_ArrayOfChar, Length(f_ArrayOfChar), $00);
    // check for invalis length
    if (Length(f_String) = 0) or (Length(f_ArrayOfChar) = 0) then
      Abort;
    // Set maximun value to process in the loop
    if Length(f_String) >= Length(f_ArrayOfChar) then
      MaxLoopVal := Length(f_ArrayOfChar) - 1
    else
      MaxLoopVal := Length(f_String) - 1;
    // now copy the Char content..
    for i := 0 to MaxLoopVal do
      f_ArrayOfChar[i] := f_String[i + 1];
  except
    exit;
  end;
  Result := True;
end;


end.

