unit BTMPEGAudioConversionsUtil;

 {* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
  * Copyright (c) 2006 by Martin Offenwanger / coder@dsplayer.de            *
  * http://www.dsplayer.com                                                 *
  *                                                                         *
  * This library is free software; you can redistribute it and/or           *
  * modify it under the terms of the GNU Lesser General Public              *
  * License as published by the Free Software Foundation; either            *
  * version 2.1 of the License, or (at your option) any later version.      *
  *                                                                         *
  * This library is distributed in the hope that it will be useful,         *
  * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
  * Lesser General Public License for more details.                         *
  *                                                                         *
  * You should have received a copy of the GNU Lesser General Public        *
  * License along with this library; if not, write to the Free Software     *
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA *
  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{
@author(Martin Offenwanger: coder@dsplayer.de)
@created(Jul 17, 2006)
@lastmod(Nov 07, 2006)
@version(0.14 alpha)
}

{$IFDEF FPC}
{$MODE Delphi}
{$ENDIF}

interface

uses
  SysUtils, BTMPEGAudioTables, BTMPEGAudioTypes;


function BTMPEGAudPropToMPEGAudPropStr(f_FrameHeader:
  TBTMPEGAudioProperties): TBTMPEGAudioPropertyStrings;


implementation

function BTMPEGAudPropToMPEGAudPropStr(f_FrameHeader:
  TBTMPEGAudioProperties): TBTMPEGAudioPropertyStrings;
var
  Temp1, Temp2: string;
begin
  Result.FrameOffset := IntToStr(f_FrameHeader.FrameOffset);
  Result.FileSize := IntToStr(f_FrameHeader.FileSize) + ' bytes';
  Result.Version := MPEGAudioVersionStrings[f_FrameHeader.Version];
  Result.Layer := MPEGAudioLayerStrings[f_FrameHeader.Layer];
  Result.CRCProtected := MPEGAudioCRCProtectedStrings[
    Integer(f_FrameHeader.CRCProtected)];
  Result.Bitrate := IntToStr(f_FrameHeader.Bitrate) + ' kbps';
  Result.Samplerate := IntToStr(f_FrameHeader.Samplerate) + ' Hz';
  Result.Padding := MPEGAudioPaddingBitStrings[
    Integer(f_FrameHeader.Padding)];
  Result.PrivateBit := MPEGAudioPrivateBitStrings[
    Integer(f_FrameHeader.PrivateBit)];
  Result.CannelMode := MPEGAudioChannelModeStrings[
    f_FrameHeader.CannelMode];
  if f_FrameHeader.CannelMode = MPEGAudioChannelModeJointStereo then begin
    if (f_FrameHeader.Layer = 1) or
      (f_FrameHeader.Layer = 2) then begin
      Result.StereoExtensions :=
        MPEGAudioLayer12ModeExStrings[f_FrameHeader.LowBand];
    end;
    if (f_FrameHeader.Layer = 3) then begin
      if f_FrameHeader.IntensityStereo then
        Temp1 := 'on'
      else
        Temp1 := 'off';
      if f_FrameHeader.MSStereo then
        Temp2 := 'on'
      else
        Temp2 := 'off';
      Result.StereoExtensions := 'Itensity stereo: ' + Temp1 +
        ' / MS stereo: ' + Temp2;
    end;
  end else
    Result.StereoExtensions := 'No mode extension';
  Result.CopyRighted := MPEGAudioCopyRightStrings[
    Integer(f_FrameHeader.CopyRighted)];
  Result.Original := MPEGAudioOriginalStrings[Integer(f_FrameHeader.Original)];
  Result.Emphasis := MPEGAudioEmphasisStrings[
    Integer(f_FrameHeader.Emphasis)];
  Result.FrameLength := IntToStr(f_FrameHeader.FrameLength) + ' bytes';
  Result.NbrOfFrames := IntToStr(f_FrameHeader.NbrOfFrames);
  Result.LengthInSeconds := InttoStr(f_FrameHeader.LengthInSeconds) + ' seconds';
  if f_FrameHeader.VariableBitRate then
    Result.VBR_CBR := 'VBR'
  else
    Result.VBR_CBR := 'CBR';
end;





end.

