unit BTMPEGAudioTypes;

 {* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
  * Copyright (c) 2006 by Martin Offenwanger / coder@dsplayer.de            *
  * http://www.dsplayer.com                                                 *
  *                                                                         *
  * This library is free software; you can redistribute it and/or           *
  * modify it under the terms of the GNU Lesser General Public              *
  * License as published by the Free Software Foundation; either            *
  * version 2.1 of the License, or (at your option) any later version.      *
  *                                                                         *
  * This library is distributed in the hope that it will be useful,         *
  * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
  * Lesser General Public License for more details.                         *
  *                                                                         *
  * You should have received a copy of the GNU Lesser General Public        *
  * License along with this library; if not, write to the Free Software     *
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA *
  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{
@author(Martin Offenwanger: coder@dsplayer.de)
@created(Jul 17, 2006)
@lastmod(Nov 07, 2006)
@version(0.14 alpha)
}

{$IFDEF FPC}
{$MODE Delphi}
{$ENDIF}

interface

type

  (*
      The Mp3 Frame Header have a binary size of 4 Bytes
      => TMP3BinaryFrameHeader a the binarey Header from the mp3 File <=
  *)
  TBTMPEGAudioBinaryFrameHeader = array [1..4] of Byte;

  (*
      Eeasy to use struct for use with view only operations
  *)
  TBTMPEGAudioPropertyStrings = record
    FrameOffset: string;
    FileSize: string;
    Version: string;
    Layer: string;
    CRCProtected: string;
    BitRate: string;
    SampleRate: string;
    Padding: string;
    PrivateBit: string;
    CannelMode: string;
    Bands: string;
    StereoExtensions: string;
    CopyRighted: string;
    Original: string;
    Emphasis: string;
    FrameLength: string;
    NbrOfFrames: string;
    LengthInSeconds: string;
    VBR_CBR: string;
  end;
  PBTMPEGAudioPropertyStrings = ^TBTMPEGAudioPropertyStrings;

  (*
      Stores several mp3 header informatons
  *)
  TBTMPEGAudioProperties = record
    FrameOffset: Integer;  (* if parsing whole file, this is the offset
                              of the first found frame *)
    FileSize: Int64; // in bytes
    // Duration: longint; // seconds
    Version: Byte; // MPEG Audio version ( 1 = v1 , 2 = v2 , 3 = v2.5 )
    Layer: Byte; // MPEG Audio Layer
    CRCProtected: Boolean; // True 16bit crc header follows
    BitRate: integer; // kbps
    SampleRate: integer; // Hz
    Padding: Boolean; // Padding Flag "True = Padding Bit is set"
    PrivateBit: Boolean; // can used freely  "True = Private Bit is set"
    CannelMode: Byte; (* 0 = Stereo, 1 = Joint stereo (Stereo),
                         2 = Dual channel (Stereo), 3 = Single channel (Mono) *)
    LowBand: Byte; // only valid for Layer I & II and Joint stereo
    HighBand: Byte; // only valid for Layer I & II and Joint stereo
    IntensityStereo: Boolean; // only valid for Layer III and Joint stereo
    MSStereo: Boolean; // only valid for Layer III and Joint stereo
    CopyRighted: Boolean; // copyright information
    Original: Boolean; // original info
    Emphasis: Byte; // get from table MPEGAudioEmphasisStrings[Emphasis: Byte]
    FrameLength: Integer; // in bytes
    NbrOfFrames: Integer;
    LengthInSeconds: Integer;
    VariableBitRate: Boolean;
  end;
  PBTMPEGAudioProperties = ^TBTMPEGAudioProperties;


  TMPEGAudioPropertyConfigSet = (
    // ID3 Tag info
    m3iArtist, m3iTitle, m3iTrack, m3iAlbum, m3iYear, m3iGenre, m3iComment,
    // parts of the frame Header Info
    m3iVersion, m3iLayer, m3iBitrate, m3iSamplerate, m3iCannelMode
    );
  TMPEGAudioPropertyConfig = set of TMPEGAudioPropertyConfigSet;
  
  
  TMPEGParseConfig = Integer;
var
  ParseSingleFrameApprox_CBR: TMPEGParseConfig = 1;
  //xy todo: ParseMultiFrameApprox: TMPEGParseConfig = 2;
  ParseComplete_CBR_VBR: TMPEGParseConfig = 3;


implementation

end.

